﻿

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Reflection;
using System.Diagnostics;
using Microsoft.Win32;
using System.Windows.Forms;

//irc key: cestquiqui



namespace SpriteToolGUI
{
    public partial class Form1 : Form
    {
        string startdir = Assembly.GetExecutingAssembly().Location.Substring(0,Assembly.GetExecutingAssembly().Location.LastIndexOf("\\") + 1);
        string longrom;
        string longsprite;
        //bool rerun;
        //Queue<stint> q;
        const int over = 614;
        const int main = 870;
        const int init = 3942;
        const int twek = 7014;
        const int size = 15289;
        string[] types = 
        {
            "Sprites",
            "Shooters",
            "Generators"
        };
        public Form1(string[] ags)
        {
            InitializeComponent();
            if (ags.Length > 1)
            {
                if (ags[0][1] != ':')
                    ags[0] = startdir + ags[0];
                longrom = ags[0];
                if (ags[1].EndsWith("cfg"))
                {
                    if (ags.Length > 4)
                    {
                        int type = stringToBlank(ags[3], 10);
                        radioButton1.Checked = type == 0;
                        radioButton2.Checked = type == 1;
                        radioButton3.Checked = type == 2;
                        if (ags[1][1] != ':')
                            ags[1] = startdir + types[type] + "\\" + ags[1];
                        longsprite = ags[1];
                        numericUpDown1.Value = (decimal)stringToBlank(ags[2], 16);
                        e1.Checked = ags[4].Contains('0');
                        e2.Checked = ags[4].Contains('1');
                        e3.Checked = ags[4].Contains('2');
                        e4.Checked = ags[4].Contains('3');
                        single.Checked = true;
                    }
                }
                else
                {
                    if (ags[1][1] != ':')
                        ags[1] = startdir + ags[1];
                    longsprite = ags[1];
                    single.Checked = false;
                }
                button2_Click(null, null);
            }
            //q = new Queue<stint>();
        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog od = new OpenFileDialog();
            od.Filter = "ROM files|*.smc";
            if (od.ShowDialog() == DialogResult.OK)
            {
                //if (longrom != od.FileName)
                //{
                    //q = new Queue<stint>();
                    longrom = od.FileName;
                    textBox1.Text = longrom.Substring(longrom.LastIndexOf("\\") + 1);
                //}
            }
        }
        /// <summary>
        /// Gets the address of freespace found in a specified ROM
        /// </summary>
        /// <param name="rompath">The path to the ROM to look for freespace in</param>
        /// <param name="bytesneeded">The number of bytes needed to satisty the freespace requirement</param>
        /// <returns>A PC offset of the freespace</returns>
        private int getfreespace(byte[] rombyte, int bytesneeded)
        {
            if (rombyte.Length < 513 * 1024)
            {
                MessageBox.Show("ROM has not been expanded!");
                return -1;
            }
            int header = rombyte.Length % 0x8000;
            int freebytes = 0;
            int freespace = 0x80000 + header;
            for (int i = freespace; i < rombyte.Length; i++)
            {
                if (i + 4 > rombyte.Length)
                    goto skiprats;
                uint ratscheck = (uint)((rombyte[i] << 24) | (rombyte[i + 1] << 16) | (rombyte[i + 2] << 8) | rombyte[i + 3]);
                if (ratscheck == 0x53544152)
                {   //we has RATS tag!
                    if (freebytes >= bytesneeded)
                        return freespace;
                    i += 7 + rombyte[i + 4] + (rombyte[i + 5] * 0x100);
                    freespace = i + 1;
                    freebytes = 0;
                    continue;
                }
            skiprats:
                if (rombyte[i] != 0 || (i - header) % 0x8000 == 0)
                {
                    if (freebytes >= bytesneeded)
                        return freespace;
                    freespace = i + 1;
                    freebytes = 0;
                    continue;
                }
                freebytes++;
            }
            MessageBox.Show("Insufficient free space found!");
            return -2;
        }
        public static int PCSNES(int Address, int Header)
        {
            return ((Address & 0x3F8000) << 1) + (((Address - Header) & 0x7FFF) + 0x8000);
        }
        public static int SNESPC(int Address, int Header)
        {
            return (((Address & 0xFF0000) >> 1) + ((Address & 0x7FFF) + Header));
        }
        private string runxkas(string asm, string rom)
        {
            string xkaspath = asm.Substring(0, asm.LastIndexOf("\\")) + "\\xkas6.exe";
            bool xexists = File.Exists(xkaspath);
            if (!xexists)
                RecreateResource("xkas6.exe",xkaspath);
            Process p = new Process();
            p.StartInfo.FileName = xkaspath;
            p.StartInfo.Arguments = "\"" + asm + "\" \"" + rom + "\"";
            p.StartInfo.UseShellExecute = false;
            p.StartInfo.RedirectStandardOutput = true;
            p.StartInfo.CreateNoWindow = true;
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo.WorkingDirectory = asm.Substring(0, asm.LastIndexOf("\\") + 1);
            p.Start();
            p.WaitForExit(4000);
            if (!p.HasExited)
                p.CloseMainWindow();
            return p.StandardOutput.ReadToEnd();
        }
        private string runtrasm(string asm)
        {
            string trasmpath = asm.Substring(0, asm.LastIndexOf("\\")) + "\\trasm.exe";
            bool texists = File.Exists(trasmpath);
            if (!texists)
                RecreateResource("trasm.exe", trasmpath);
            Process p = new Process();
            p.StartInfo.FileName = trasmpath;
            p.StartInfo.Arguments = "\"" + asm + "\"";
            p.StartInfo.UseShellExecute = false;
            p.StartInfo.RedirectStandardOutput = true;
            p.StartInfo.CreateNoWindow = true;
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo.WorkingDirectory = asm.Substring(0, asm.LastIndexOf("\\") + 1);
            p.Start();
            p.WaitForExit(4000);
            if (!p.HasExited)
                p.CloseMainWindow();
            return p.StandardOutput.ReadToEnd();
        }
        private void RecreateResource(string filename, string saveAsName)
        {
            // Get Current Assembly refrence
            Assembly currentAssembly = Assembly.GetExecutingAssembly();
            // Get all imbedded resources
            string[] arrResources = currentAssembly.GetManifestResourceNames();

            foreach (string resourceName in arrResources)
            {
                if (resourceName.EndsWith(filename))
                {
                    //Name of the file saved on disk;
                    FileInfo fileInfoOutputFile = new FileInfo(saveAsName);
                    //CHECK IF FILE EXISTS AND DO SOMETHING DEPENDING ON YOUR NEEDS
                    if (fileInfoOutputFile.Exists)
                    {
                        File.Delete(fileInfoOutputFile.ToString());
                    }
                    //OPEN NEWLY CREATING FILE FOR WRITTING
                    FileStream streamToOutputFile = fileInfoOutputFile.OpenWrite();
                    //GET THE STREAM TO THE RESOURCES
                    Stream streamToResourceFile =
                                        currentAssembly.GetManifestResourceStream(resourceName);

                    //---------------------------------
                    //SAVE TO DISK OPERATION
                    //---------------------------------
                    const int size = 4096;
                    byte[] bytes = new byte[4096];
                    int numBytes;
                    while ((numBytes = streamToResourceFile.Read(bytes, 0, size)) > 0)
                    {
                        streamToOutputFile.Write(bytes, 0, numBytes);
                    }

                    streamToOutputFile.Close();
                    streamToResourceFile.Close();
                }//end_if

            }//end_foreach
        }
        private void button2_Click(object sender, EventArgs e)
        {
            if (single.Checked)
            {
                byte overrideflags = 0;
                if (e1.Checked)
                    overrideflags = 0x10;
                if (e2.Checked)
                    overrideflags |= 0x20;
                if (e3.Checked)
                    overrideflags |= 0x40;
                if (e4.Checked)
                    overrideflags |= 0x80;
                insertasprite(longsprite, (int)numericUpDown1.Value, overrideflags,gettype());
                return;
            }
            string[] sprites = File.ReadAllLines(longsprite);
            string genericpath = longsprite.Substring(0, longsprite.LastIndexOf('\\') + 1);
            string theoneinthelist;
            byte genericbits = 0xC0;
            byte bitstodo = 0;
            int spritenum = 0;
            int type = -1;
            foreach (string sprite in sprites)
            {
                bitstodo = 0;
                int currpos = 0;
                spritenum++;
                if (sprite.Length == 0)
                    continue;
                if (sprite.StartsWith("//") || sprite.StartsWith(";"))
                    continue;
                if (sprite[0] == 'x' || sprite[0] == 'X')
                {
                    for (currpos++; currpos < 5 && sprite[currpos] != ' '; currpos++)
                    {
                        int bit = stringToBlank(sprite.Substring(currpos, 1), 10);
                        if (bit > 3)
                        {
                            MessageBox.Show("Invalid data in sprite list:\nInvalid extra bit settings.\n\nInsertion failed on sprite " + forcedigits(String.Format("{0:X}", spritenum), 2) + ".\nAll sprites up to that point have inserted correctly.");
                            return;
                        }
                        bitstodo |= (byte)(1 << bit + 4);
                    }
                    currpos++;
                }
                else
                    bitstodo = genericbits;
                if (stringToBlank(sprite.Substring(currpos, 1), 16) < 0)
                {
                    if (sprite[currpos] == 'S' || sprite[currpos] == 's')
                        type = 0;
                    else if (sprite[currpos] == 'H' || sprite[currpos] == 'h')
                        type = 1;
                    else if (sprite[currpos] == 'G' || sprite[currpos] == 'g')
                        type = 2;
                    else
                        type = gettypefromnum(stringToBlank(sprite.Substring(currpos + 1, 2), 16));
                    currpos++;
                }
                else
                    type = gettypefromnum(stringToBlank(sprite.Substring(currpos, 2), 16));
                if (type < 0)
                {
                    MessageBox.Show("Invalid data in sprite list:\nInvalid forced type. Valid type prefixes are 'S', 'H', and 'G'. Types should go before the sprite number.\n\nInsertion failed on sprite " + forcedigits(String.Format("{0:X}", spritenum), 2) + ".\nAll sprites up to that point have inserted correctly.");
                    return;
                }
                spritenum = stringToBlank(sprite.Substring(currpos, 2), 16);
                if (spritenum < 0 || spritenum > 0xFF)
                {
                    MessageBox.Show("Invalid data in sprite list:\nInvalid sprite number. Sprite numbers must be two digit hexidecimal digits between 0 and 0xFF.\n\nInsertion failed on sprite " + forcedigits(String.Format("{0:X}",spritenum),2) + ".\nAll sprites up to that point have inserted correctly.");
                    return;
                }
                currpos += 3;
                theoneinthelist = sprite.Substring(currpos);
                if (!File.Exists(startdir + types[type] + "\\" + theoneinthelist))
                {
                    MessageBox.Show("Invalid data in sprite list:\nSpecified sprite file does not exist in the " + types[type] + " subdirectory.\n\nInsertion failed on sprite " + forcedigits(String.Format("{0:X}",spritenum),2) + ".\nAll sprites up to that point have inserted correctly.");
                    return;
                }
                if (!insertasprite(startdir + types[type] + "\\" + theoneinthelist, spritenum, bitstodo, type))
                {
                    MessageBox.Show("Insertion failed on sprite " + forcedigits(String.Format("{0:X}", spritenum), 2) + ".\nAll sprites up to that point have inserted correctly.");
                    return;
                }
            }
            MessageBox.Show("All sprites inserted properly!");
        }
        private bool insertasprite (string spritename,int spritenumber,byte overrideflags,int spritetype)
        {
            if (spritenumber == 0xC8 && spritetype == 1)
            {
                MessageBox.Show("You can't have your shooter and have it be number C8, too.");
                return false;
            }
            if (spritenumber == 0xCA && spritetype == 2)
            {
                MessageBox.Show("You can't have your generator and have it be number CA, too.");
                return false;
            }
            int frsp = 0;
            int snesfrsp = 0;
            int sprfrsp = 0;
            int mainoffset = 0;
            int initoffset = 0;
            int placetypething = 0;
            byte meeperide = (byte)(overrideflags >> 4);
            //rerun = false;
            if (longrom == null || longrom == "" || !File.Exists(longrom))
            {
                MessageBox.Show("ROM file not found!\n\nError code: 07");
                return false;
            }
            byte[] rombuffer = File.ReadAllBytes(longrom);
            int header = rombuffer.Length % 0x8000;
            if (header != 0 && header != 0x200)
            {
                MessageBox.Show("Irregular ROM size!\n\nError code: 06");
                return false;
            }
            if ((rombuffer[0xFFCF + header] & rombuffer[0xFFD0 + header] & rombuffer[0xFFD1 + header]) != 0xFF)
                goto DoSprites;
            frsp = getfreespace(rombuffer, size);
            if (frsp == -1 || frsp == -2)
                return false;       //messaging done by called function
            snesfrsp = PCSNES(frsp, header);
            string[] patchfile = File.ReadAllLines(startdir + "src\\customsprites.asm");
            patchfile[0] = "!FreeSpace = $" + String.Format("{0:X}", snesfrsp) + "	;DON'T TOUCH! program will set automatically";
            if (header == 0)
                patchfile[1] = "";
            else
                patchfile[1] = "header";
            File.WriteAllLines(startdir + "src\\customsprites.asm", patchfile);
            string output = runxkas(startdir + "src\\customsprites.asm", longrom);
            if (output.Contains("error"))
            {
                output = "Source patch did not insert correctly:\n\n" + output + "\n\nHouston, we have a problem.\n\nError code: 05";
                MessageBox.Show(output);
                return false;
            }
            MessageBox.Show("Source patch assembled correctly!");
            rombuffer = File.ReadAllBytes(longrom);
            rombuffer[0xFFCF + header] = (byte)(snesfrsp >> 16);
            rombuffer[0xFFD0 + header] = (byte)((snesfrsp >> 8) & 0xFF);
            rombuffer[0xFFD1 + header] = (byte)(snesfrsp & 0xFF);
            File.WriteAllBytes(longrom, rombuffer);
        DoSprites:
            {
            }
            if (spritename == null || spritename == "" || !File.Exists(spritename))
            {
                MessageBox.Show("No sprite selected for insert!\n\nError code: 04");
                return false;
            }

            cfgdata config = new cfgdata();
            config.cfgdatainit(spritename);
            /*stint[] stq = q.ToArray();
            for (int i = 0; i < stq.Length; i++)
            {
                if (stq[i].s == config.asmfile)
                {
                    rerun = true;
                    mainoffset = stq[i].j;
                    initoffset = stq[i].i;
                    sprfrsp = 0;
                    goto Rerunlabel;
                }
            }*/
            string asmpath = spritename.Substring(0, spritename.LastIndexOf("\\") + 1) + config.asmfile;
            if (!File.Exists(asmpath))
            {
                MessageBox.Show("ASM file not found!\n\nError code: 03");
                return false;
            }
            snesfrsp = (rombuffer[0xFFCF + header] << 16) | (rombuffer[0xFFD0 + header] << 8) | rombuffer[0xFFD1 + header];
            frsp = SNESPC(snesfrsp, header);
            int[] alrrem = new int[4];
            for (int currbit = 0; currbit < 4; currbit++)
            {
                if ((meeperide & (1 << currbit)) != 0)
                {
                    placetypething = (((spritenumber << 2) + currbit)*3) + init + frsp;
                    placetypething = rombuffer[placetypething] + (rombuffer[placetypething + 1] << 8) + (rombuffer[placetypething + 2] << 16);
                    bool ljslkd = false;
                    for (int i = 0; i < 4; i++)
                    {
                        if (placetypething == alrrem[i])
                            ljslkd = true;
                    }
                    if (ljslkd)
                        continue;
                    alrrem[currbit] = placetypething;
                    placetypething = SNESPC(placetypething,header);
                    placetypething -= 4;
                    for (; ; placetypething--)
                    {
                        uint ratscheck = (uint)((rombuffer[placetypething - 4] << 24) | (rombuffer[placetypething - 3] << 16) | (rombuffer[placetypething - 2] << 8) | rombuffer[placetypething - 1]);
                        if (ratscheck == 0x53544152)
                        {
                            int ratslength = rombuffer[placetypething] + (rombuffer[placetypething + 1] << 8) + 8;
                            for (int i = 0; i < ratslength; i++)
                                rombuffer[i + placetypething - 4] = 0;
                            break;
                        }
                    }
                }
            }
            string asdfstuff = File.ReadAllText(asmpath);
            int asmsize = 0;
            if (!config.usexkas)
            {
                File.WriteAllText(startdir + "temp.asm", asdfstuff);
                output = runtrasm(startdir + "temp.asm");
                File.WriteAllText(startdir + "output.log",output);
                if (output[output.IndexOf("Errors=") + 7] != '0')
                {
                    MessageBox.Show("Sprite did not assemble correctly! A copy of the error log can be found in output.log.\n\n" + output + "\n\nError code: 09");
                    return false;
                }
                string locpointers = File.ReadAllText(startdir + "temp.bin");
                mainoffset = locpointers.IndexOf("MAIN") + 4;
                initoffset = locpointers.IndexOf("INIT") + 4;
                if (initoffset == 3)
                {
                    MessageBox.Show("INIT pointer not found!\n\nError code: 00");
                    return false;
                }
                if (mainoffset == 3)
                {
                    MessageBox.Show("MAIN pointer not found!\n\nError code: 01");
                    return false;
                }
                asmsize = File.ReadAllBytes(startdir + "temp.bin").Length;
                sprfrsp = getfreespace(rombuffer, asmsize + 8);
                if (sprfrsp == -1 || sprfrsp == -2)
                    return false;       //messaging done by called function
                asdfstuff = "org $" + String.Format("{0:X}", PCSNES(sprfrsp + 8, header)) + "\r\n" + asdfstuff;
                File.WriteAllText(startdir + "temp.asm", asdfstuff);
                runtrasm(startdir + "temp.asm");
            }
            else
            {
                asdfstuff += "\r\nprint \"SIZE: \",bytes,\"~\"";
                File.WriteAllText(startdir + "temp.asm", asdfstuff);
                output = runxkas(startdir + "temp.asm", startdir + "temp.bin");
                File.WriteAllText(startdir + "output.log", "Xkas output:\r\n\r\n" + output);
                if (output.Contains("error"))
                {
                    MessageBox.Show("Sprite did not assemble correctly! A copy of the error log can be found in output.log.\n\n" + output + "\n\nError code: 09");
                    return false;
                }
                int initloc = output.IndexOf("INIT");
                if (initloc == -1)
                {
                    MessageBox.Show("INIT pointer not found!\n\nError code: 00");
                    return false;
                }
                initoffset = stringToBlank(output.Substring(initloc + 6, 5), 16);
                int mainloc = output.IndexOf("MAIN");
                if (mainloc == -1)
                {
                    MessageBox.Show("MAIN pointer not found!\n\nError code: 01");
                    return false;
                }
                mainoffset = stringToBlank(output.Substring(mainloc + 6, 5), 16);
                int sizeloc = output.IndexOf("SIZE: ");
                if (sizeloc == -1)
                {
                    MessageBox.Show("Houston, we have a problem.\n\nError code: 02");
                    return false;
                }
                asmsize = stringToBlank(output.Substring(sizeloc + 6, output.LastIndexOf('~') - (sizeloc + 6)), 10);
                sprfrsp = getfreespace(rombuffer, asmsize + 8);
                if (sprfrsp == -1 || sprfrsp == -2)
                    return false;       //messaging done by called function
                asdfstuff = "org $" + String.Format("{0:X}", PCSNES(sprfrsp + 8, header)) + "\r\n" + asdfstuff;
                File.WriteAllText(startdir + "temp.asm", asdfstuff);
                runxkas(startdir + "temp.asm", startdir + "temp.bin");
            }
            byte[] assembly = File.ReadAllBytes(startdir + "temp.bin");
            MemoryStream ms = new MemoryStream(rombuffer);
            ms.Seek(sprfrsp, SeekOrigin.Begin);
            ms.WriteByte(0x53);
            ms.WriteByte(0x54);
            ms.WriteByte(0x41);
            ms.WriteByte(0x52);
            ms.WriteByte((byte)(asmsize & 0xFF));
            ms.WriteByte((byte)(asmsize >> 8));
            ms.WriteByte((byte)((asmsize ^ 0xFFFF) & 0xFF));
            ms.WriteByte((byte)((asmsize ^ 0xFFFF) >> 8));
            ms.Write(assembly, 0, asmsize);
            sprfrsp += 8;
            rombuffer = ms.ToArray();
        //Rerunlabel:
            snesfrsp = (rombuffer[0xFFCF + header] << 16) | (rombuffer[0xFFD0 + header] << 8) | rombuffer[0xFFD1 + header];
            frsp = SNESPC(snesfrsp, header);
            /*if (!rerun)
            {
                stint star = new stint();
                star.s = config.asmfile;
                star.i = sprfrsp + initoffset;
                star.j = sprfrsp + mainoffset;
                q.Enqueue(star);
            }*/
            byte currflags = rombuffer[frsp + over + spritenumber];
            for (int currbit = 0; currbit < 4; currbit++)
            {
                if ((meeperide & (1 << currbit)) != 0)
                {
                    currflags |= (byte)((spritetype + 1) << ((3 - currbit) * 2));
                }
            }
            rombuffer[frsp + over + spritenumber] = currflags;
            snesfrsp = PCSNES(mainoffset + sprfrsp, header);
            for (int currbit = 0; currbit < 4; currbit++)
            {
                if ((meeperide & (1 << currbit)) != 0)
                {
                    placetypething = frsp + main + (((spritenumber << 2) | currbit) * 3);
                    rombuffer[placetypething] = (byte)((snesfrsp) & 0xFF);
                    rombuffer[placetypething + 1] = (byte)(((snesfrsp) >> 8) & 0xFF);
                    rombuffer[placetypething + 2] = (byte)(((snesfrsp) >> 16) & 0xFF);
                }
            }
            snesfrsp = PCSNES(initoffset + sprfrsp, header);
            for (int currbit = 0; currbit < 4; currbit++)
            {
                if ((meeperide & (1 << currbit)) != 0)
                {
                    placetypething = frsp + init + (((spritenumber << 2) | currbit) * 3);
                    rombuffer[placetypething] = (byte)((snesfrsp) & 0xFF);
                    rombuffer[placetypething + 1] = (byte)(((snesfrsp) >> 8) & 0xFF);
                    rombuffer[placetypething + 2] = (byte)(((snesfrsp) >> 16) & 0xFF);
                }
            }

            for (int currbit = 0; currbit < 4; currbit++)
            {
                if ((meeperide & (1 << currbit))!= 0)
                {
                    placetypething = frsp + twek + (((spritenumber << 2) | currbit) * 8);
                    rombuffer[placetypething] = config.sixteenfiftysix;
                    rombuffer[placetypething + 1] = config.sixteensixtytwo;
                    rombuffer[placetypething + 2] = config.sixteensixE;
                    rombuffer[placetypething + 3] = config.sixteensevenA;
                    rombuffer[placetypething + 4] = config.sixteeneightysix;
                    rombuffer[placetypething + 5] = config.nineteenohF;
                    rombuffer[placetypething + 6] = config.extraone;
                    rombuffer[placetypething + 7] = config.extratwo;
                }
            }
            if (single.Checked)
                MessageBox.Show("Sprite inserted successfully! Location: $" + String.Format("{0:X}", PCSNES(sprfrsp - 8, header)));
            File.WriteAllBytes(longrom, rombuffer);
            return true;
        }
        private void button3_Click(object sender, EventArgs e)
        {
            OpenFileDialog od = new OpenFileDialog();
            od.Filter = "Sprite lists (.txt)|*.txt";
            if (single.Checked)
                od.Filter = "Sprite files (.cfg)|*.cfg";
            if (od.ShowDialog() == DialogResult.OK)
            {
                longsprite = od.FileName;
                textBox2.Text = longsprite.Substring(longsprite.LastIndexOf("\\") + 1);
            }
        }
        public int stringToBlank(string todo, int basetodo)
        {
            int fin = 0;
            for (int i = 0; i < todo.Length; i++)
            {
                int temp = 0;
                switch (todo[todo.Length - 1 - i])
                {
                    case '0':
                        {
                            break;
                        }
                    case '1':
                        {
                            temp++;
                            break;
                        }
                    case '2':
                        {
                            temp = 2;
                            break;
                        }
                    case '3':
                        {
                            temp = 3;
                            break;
                        }
                    case '4':
                        {
                            temp = 4;
                            break;
                        }
                    case '5':
                        {
                            temp = 5;
                            break;
                        }
                    case '6':
                        {
                            temp = 6;
                            break;
                        }
                    case '7':
                        {
                            temp = 7;
                            break;
                        }
                    case '8':
                        {
                            temp = 8;
                            break;
                        }
                    case '9':
                        {
                            temp = 9;
                            break;
                        }
                    case 'A':
                    case 'a':
                        {
                            temp = 10;
                            break;
                        }
                    case 'B':
                    case 'b':
                        {
                            temp = 11;
                            break;
                        }
                    case 'C':
                    case 'c':
                        {
                            temp = 12;
                            break;
                        }
                    case 'D':
                    case 'd':
                        {
                            temp = 13;
                            break;
                        }
                    case 'E':
                    case 'e':
                        {
                            temp = 14;
                            break;
                        }
                    case 'F':
                    case 'f':
                        {
                            temp = 15;
                            break;
                        }
                    default:
                        {
                            temp = -1;
                            break;
                        }
                }
                fin += temp * (int)Math.Pow(basetodo, i);
            }
            return fin;
        }
        private string forcedigits(string start, int digits)
        {
            if (start.Length >= digits)
                return start.Substring(start.Length - digits);
            while (start.Length < digits)
                start = "0" + start;
            return start;
        }
        struct cfgdata
        {
            public byte sixteenfiftysix;
            public byte sixteensixtytwo;
            public byte sixteensixE;
            public byte sixteensevenA;
            public byte sixteeneightysix;
            public byte nineteenohF;
            public byte extraone;
            public byte extratwo;
            public byte actslike;
            public bool custom;
            public bool usexkas;
            public string asmfile;
            public void cfgdatainit(string cfgpath)
            {
                string[] bleh = File.ReadAllLines(cfgpath);
                custom = false;
                if (bleh[0] == "01")
                    custom = true;
                sixteenfiftysix = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].IndexOf(' ')), 16);
                bleh[2] = bleh[2].Substring(bleh[2].IndexOf(' ') + 1);
                sixteensixtytwo = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].IndexOf(' ')), 16);
                bleh[2] = bleh[2].Substring(bleh[2].IndexOf(' ') + 1);
                sixteensixE = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].IndexOf(' ')), 16);
                bleh[2] = bleh[2].Substring(bleh[2].IndexOf(' ') + 1);
                sixteensevenA = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].IndexOf(' ')), 16);
                bleh[2] = bleh[2].Substring(bleh[2].IndexOf(' ') + 1);
                sixteeneightysix = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].IndexOf(' ')), 16);
                bleh[2] = bleh[2].Substring(bleh[2].IndexOf(' ') + 1);
                nineteenohF = (byte)stringToBlank(bleh[2].Substring(0, bleh[2].Length), 16);
                extraone = (byte)stringToBlank(bleh[3].Substring(0, bleh[3].IndexOf(' ')), 16);
                bleh[3] = bleh[3].Substring(bleh[3].IndexOf(' ') + 1);
                extratwo = (byte)stringToBlank(bleh[3].Substring(0, bleh[3].Length), 16);
                asmfile = bleh[4];
                usexkas = false;
                if (bleh.Length == 6 && bleh[5] == "1")
                    usexkas = true;
                actslike = (byte)stringToBlank(bleh[1], 16);
            }

            public int stringToBlank(string todo, int basetodo)
            {
                int fin = 0;
                for (int i = 0; i < todo.Length; i++)
                {
                    int temp = 0;
                    switch (todo[todo.Length - 1 - i])
                    {
                        case '1':
                            {
                                temp++;
                                break;
                            }
                        case '2':
                            {
                                temp = 2;
                                break;
                            }
                        case '3':
                            {
                                temp = 3;
                                break;
                            }
                        case '4':
                            {
                                temp = 4;
                                break;
                            }
                        case '5':
                            {
                                temp = 5;
                                break;
                            }
                        case '6':
                            {
                                temp = 6;
                                break;
                            }
                        case '7':
                            {
                                temp = 7;
                                break;
                            }
                        case '8':
                            {
                                temp = 8;
                                break;
                            }
                        case '9':
                            {
                                temp = 9;
                                break;
                            }
                        case 'A':
                        case 'a':
                            {
                                temp = 10;
                                break;
                            }
                        case 'B':
                        case 'b':
                            {
                                temp = 11;
                                break;
                            }
                        case 'C':
                        case 'c':
                            {
                                temp = 12;
                                break;
                            }
                        case 'D':
                        case 'd':
                            {
                                temp = 13;
                                break;
                            }
                        case 'E':
                        case 'e':
                            {
                                temp = 14;
                                break;
                            }
                        case 'F':
                        case 'f':
                            {
                                temp = 15;
                                break;
                            }
                    }
                    fin += temp * (int)Math.Pow(basetodo, i);
                }
                return fin;
            }
        }
        /*struct stint
        {
            public string s;
            public int i;
            public int j;
        }*/
        private void single_CheckedChanged(object sender, EventArgs e)
        {
            e1.Enabled = e2.Enabled = e3.Enabled = e4.Enabled = numericUpDown1.Enabled = radioButton1.Enabled = radioButton2.Enabled = radioButton3.Enabled = single.Checked;
            textBox2.Text = "";
        }
        private int gettype()
        {
            if (radioButton1.Checked)
                return 0;
            if (radioButton2.Checked)
                return 1;
            if (radioButton3.Checked)
                return 2;
            return -1;
        }
        private int gettypefromnum(int spritenum)
        {
            if (spritenum < 0xC0)
                return 0;
            if (spritenum > 0xCF)
                return 2;
            return 1;
        }
    }
}
